program ComplexDemo (Output);

var
  z1, z2 : Complex;
  Len, Angle : Real;

begin
  z1 := Cmplx (2, 1);
  Writeln;
  Writeln ('Complex number z1 is: (', Re (z1) : 1, ',', Im (z1) : 1, ')');
  Writeln;
  z2 := Conjugate(z1); { GPC extension }
  Writeln ('Conjugate of z1 is: (', Re (z2) : 1, ',', Im (z2) : 1, ')');
  Writeln;
  Len   := Abs (z1);
  Angle := Arg (z1);
  Writeln ('The polar representation of z1 is: Length=', Len : 1,
           ', Angle=', Angle : 1);
  Writeln;
  z2 := Polar (Len, Angle);
  Writeln ('Converting (Length, Angle) back to (x, y) gives: (',
           Re (z2) : 1, ',', Im (z2) : 1, ')');
  Writeln;
  Writeln ('The following operations operate on the complex number z1');
  Writeln;
  z2 := ArcTan (z1);
  Writeln ('arctan (z1) = (', Re (z2), ', ', Im (z2), ')');
  Writeln;
  z2 := z1 ** 3.141;
  Writeln ('z1 ** 3.141 =', Re (z2), ', ', Im (z2), ')');
  Writeln;
  z2 := Sin (z1);
  Writeln ('sin (z1) = (', Re (z2), ', ', Im (z2), ')');
  Writeln ('(cos, ln, exp, sqrt and sqr exist also.)');
  Writeln;
  z2 := z1 pow 8;
  Writeln ('z1 pow 8 = (', Re (z2), ', ', Im (z2), ')');
  Writeln;
  z2 := z1 pow (-8);
  Writeln ('z1 pow (-8) = (', Re (z2), ', ', Im (z2), ')');
end.
